{
module Scanner where
}

%wrapper "basic"

$digit = 0-9			-- digits
$alpha = [a-zA-Z]		-- alphabetic characters

tokens :-

  $white+				;
  "--".*				;
  program				{ \s -> Tprogram }
  read					{ \s -> Tread }
  write					{ \s -> Twrite }
  for					{ \s -> Tfor }
  to					{ \s -> Tto }
  do					{ \s -> Tdo }
  begin					{ \s -> Tbegin }
  end					{ \s -> Tend }
  ":="                                  { \s -> Tassign }
  ";"                                   { \s -> Tsemicolon }
  "+"                                   { \s -> Tplus }
  "-"                                   { \s -> Tminus }
  "*"                                   { \s -> Ttimes }
  "("                                   { \s -> Tlparen }
  ")"                                   { \s -> Trparen }
  "."                                   { \s -> Tdot }
  $digit+				{ \s -> Tint (read s) }
  [\=\+\-\*\/\(\)]			{ \s -> Tother (head s) }
  $alpha [$alpha $digit \_ \']*		{ \s -> Tvar s }

{
-- Each action has type :: String -> Token

-- The token type:
data Token = Tprogram
           | Tread      | Twrite   | Tfor       | Tassign
           | Tto        | Tdo      | Tbegin     | Tend
           | Tsemicolon | Tplus    | Tminus     | Ttimes
           | Tlparen    | Trparen  | Tdot       | Tother Char
           | Tint Int              | Tvar String 
           deriving (Eq,Show)


}
